/*****************************************************************************/
/* main.h : Interface et appels d'un arbre
 * main.h : Tree's interface and callbacks
 *
 *
 * Greffon ToutDoux : Fossile : Arbre d'actions pour projet infomatique
 * ToutDoux's plug-in : Fossile : Simple actions tree for computer project
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#include <toutdoux.h>


/*****************************************************************************/
/* Variables globales */
/*****************************************************************************/
GtkObject *mod; /* Module */

/*****************************************************************************/
/* Module */
/*****************************************************************************/
GtkObject *plugins_about_def (void);
void mod_about (void);
GtkObject *plugins_mod_def (void);
void plugins_init (int mod_id);
void plugins_show (void);
void plugins_hide (void);
void plugins_destroy (void);
void plugins_custom (void);

/*****************************************************************************/
/* Proprits */
/*****************************************************************************/
void prop_name (GtkWidget *widget, GtkObject *mod_tree);
void prop_version (GtkWidget *widget, GtkObject *mod_tree);
void prop_planned (GtkWidget *widget, GtkObject *mod_tree);
void prop_design (GtkWidget *widget, GtkObject *mod_tree);
void prop_construction (GtkWidget *widget, GtkObject *mod_tree);

/*****************************************************************************/
/* Menus */
/*****************************************************************************/
void menu_new (GtkMenuItem *menuitem, gpointer user_data);
void menu_remove (GtkMenuItem *menuitem, gpointer user_data);

/*****************************************************************************/
/* Fichier */
/*****************************************************************************/
void plugins_load (GtkObject *datatable);
GtkObject *plugins_save (void);
